%global _hardened_build 1
%global __provides_exclude_from ^(%{python3_sitearch}/.*\\.so)$

%global open_iscsi_version	2.1
%global open_iscsi_build	4
%global commit0				2a8f9d81d0d6b5094c3fe9c686e2afb2ec27058a
%global shortcommit0		%(c=%{commit0}; echo ${c:0:7})

%undefine _ld_as_needed

Summary:		iSCSI daemon and utility programs
Name:			iscsi-initiator-utils
Version:		6.%{open_iscsi_version}.%{open_iscsi_build}
Release:		5.git%{shortcommit0}%{?dist}
License:		GPLv2+
URL:			https://github.com/open-iscsi/open-iscsi
Source0:		https://github.com/open-iscsi/open-iscsi/archive/%{commit0}.tar.gz#/open-iscsi-%{shortcommit0}.tar.gz
Source1:		04-iscsi
Source2:		iscsi-tmpfiles.conf

Patch0001:		0001-unit-file-tweaks.patch
Patch0002:		0002-idmb_rec_write-check-for-tpgt-first.patch
Patch0003:		0003-idbm_rec_write-seperate-old-and-new-style-writes.patch
Patch0004:		0004-idbw_rec_write-pick-tpgt-from-existing-record.patch
Patch0005:		0005-update-initscripts-and-docs.patch
Patch0006:		0006-use-var-for-config.patch
Patch0007:		0007-libiscsi.patch
Patch0008:		0008-Add-macros-to-release-GIL-lock.patch
Patch0009:		0009-libiscsi-introduce-sessions-API.patch
Patch0010:		0010-libiscsi-fix-discovery-request-timeout-regression.patch
Patch0011:		0011-libiscsi-format-security-build-errors.patch
Patch0012:		0012-libiscsi-fix-build-to-use-libopeniscsiusr.patch
Patch0013:		0013-libiscsi-fix-build-against-latest-upstream-again.patch
Patch0014:		0014-remove-the-offload-boot-supported-ifdef.patch
Patch0015:		0015-Revert-iscsiadm-return-error-when-login-fails.patch
Patch0016:		0016-dont-install-scripts.patch
Patch0017:		0017-use-var-lib-iscsi-in-libopeniscsiusr.patch
Patch0018:		0018-Coverity-scan-fixes.patch
Patch0019:		0019-fix-upstream-build-breakage-of-iscsiuio-LDFLAGS.patch
Patch0020:		0020-use-Red-Hat-version-string-to-match-RPM-package-vers.patch
Patch0021:		0021-iscsi_if.h-replace-zero-length-array-with-flexible-a.patch
Patch0022:		0022-stop-using-Werror-for-now.patch
Patch0023:		0023-minor-service-file-updates.patch
Patch0024:		0024-Remove-dependences-from-iscsi-init.service.patch

Patch5000:		5000-use-opencloudos-as-default-iqn-name.patch

BuildRequires:	flex bison doxygen systemd-units make autoconf automake libtool
BuildRequires:	isns-utils-devel systemd-devel libmount-devel openssl-devel
BuildRequires:  python3-devel python3-setuptools kmod-devel
Requires:		%{name}-iscsiuio >= %{version}-%{release}
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
The iscsi package provides the server daemon for the iSCSI protocol,
as well as the utility programs used to manage it. iSCSI is a protocol
for distributed disk access using SCSI commands sent over Internet
Protocol networks.

%package iscsiuio
Summary:		Userspace configuration daemon required for some iSCSI hardware
License:		BSD
Requires:		%{name} = %{version}-%{release}

%description iscsiuio
The iscsiuio configuration daemon provides network configuration help
for some iSCSI offload hardware.

%package devel
Summary:		Development files for %{name}
Requires:		%{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package -n python3-%{name}
Summary:		Python 3 bindings to %{name}
Requires:		%{name} = %{version}-%{release}

%description -n python3-%{name}
The %{name}-python3 package contains Python %{python3_version} bindings to the
libiscsi interface for interacting with %{name}

%prep
%autosetup -p1 -n open-iscsi-%{commit0}
sed -i -e 's|^exec_prefix = /$|exec_prefix = %{_exec_prefix}|' Makefile

%build
pushd iscsiuio
autoreconf --install
%configure
popd

%make_build

pushd libiscsi
%py3_build
touch -r libiscsi.doxy html/*
popd

%install
make DESTDIR=%{buildroot} install_programs install_doc install_etc install_libopeniscsiusr
rm -f %{buildroot}%{_mandir}/man8/iscsi_discovery.8
rm -f %{buildroot}%{_mandir}/man8/iscsi_fw_login.8
install -pm 755 usr/iscsistart %{buildroot}%{_sbindir}
install -pm 644 doc/iscsistart.8 %{buildroot}%{_mandir}/man8
install -pm 644 doc/iscsi-iname.8 %{buildroot}%{_mandir}/man8
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -pm 644 iscsiuio/iscsiuiolog %{buildroot}%{_sysconfdir}/logrotate.d

install -d %{buildroot}%{_sharedstatedir}/iscsi
install -d %{buildroot}%{_sharedstatedir}/iscsi/nodes
install -d %{buildroot}%{_sharedstatedir}/iscsi/send_targets
install -d %{buildroot}%{_sharedstatedir}/iscsi/static
install -d %{buildroot}%{_sharedstatedir}/iscsi/isns
install -d %{buildroot}%{_sharedstatedir}/iscsi/slp
install -d %{buildroot}%{_sharedstatedir}/iscsi/ifaces

install -d %{buildroot}%{_rundir}/lock/iscsi
touch %{buildroot}%{_rundir}/lock/iscsi/lock
install -d %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi-init.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi-onboot.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsi-shutdown.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsid.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsid.socket %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsiuio.service %{buildroot}%{_unitdir}
install -pm 644 etc/systemd/iscsiuio.socket %{buildroot}%{_unitdir}

install -d %{buildroot}%{_libexecdir}
install -pm 755 etc/systemd/iscsi-mark-root-nodes %{buildroot}%{_libexecdir}

install -d %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d
install -pm 755 %{SOURCE1} %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d

install -d %{buildroot}%{_tmpfilesdir}
install -pm 644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/iscsi.conf

install -d %{buildroot}%{_libdir}
install -pm 755 libiscsi/libiscsi.so.0 %{buildroot}%{_libdir}
ln -s libiscsi.so.0 %{buildroot}%{_libdir}/libiscsi.so
install -d %{buildroot}%{_includedir}
install -pm 644 libiscsi/libiscsi.h %{buildroot}%{_includedir}

install -d %{buildroot}%{python3_sitearch}
pushd libiscsi
%py3_install
popd

%post
%systemd_post iscsi.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%preun
%systemd_preun iscsi.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%postun
%systemd_postun iscsi.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%post iscsiuio
%systemd_post iscsiuio.service iscsiuio.socket

%preun iscsiuio
%systemd_preun iscsiuio.service iscsiuio.socket

%postun iscsiuio
%systemd_postun iscsiuio.service iscsiuio.socket

%files
%license COPYING
%doc README
%dir %{_sharedstatedir}/iscsi
%dir %{_sharedstatedir}/iscsi/nodes
%dir %{_sharedstatedir}/iscsi/isns
%dir %{_sharedstatedir}/iscsi/static
%dir %{_sharedstatedir}/iscsi/slp
%dir %{_sharedstatedir}/iscsi/ifaces
%dir %{_sharedstatedir}/iscsi/send_targets
%ghost %attr(0700, root, root) %{_rundir}/lock/iscsi
%ghost %attr(0600, root, root) %{_rundir}/lock/iscsi/lock
%{_unitdir}/iscsi.service
%{_unitdir}/iscsi-onboot.service
%{_unitdir}/iscsi-init.service
%{_unitdir}/iscsi-shutdown.service
%{_unitdir}/iscsid.service
%{_unitdir}/iscsid.socket
%{_libexecdir}/iscsi-mark-root-nodes
%{_prefix}/lib/NetworkManager
%{_tmpfilesdir}/iscsi.conf
%dir %{_sysconfdir}/iscsi
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/iscsi/iscsid.conf
%{_sbindir}/iscsi-iname
%{_sbindir}/iscsiadm
%{_sbindir}/iscsid
%{_sbindir}/iscsistart
%{_libdir}/libiscsi.so.0
%{_libdir}/libopeniscsiusr.so.*
%{_mandir}/man8/iscsi-iname.8.gz
%{_mandir}/man8/iscsiadm.8.gz
%{_mandir}/man8/iscsid.8.gz
%{_mandir}/man8/iscsistart.8.gz

%files iscsiuio
%{_unitdir}/iscsiuio.service
%{_unitdir}/iscsiuio.socket
%config(noreplace) %{_sysconfdir}/logrotate.d/iscsiuiolog
%{_sbindir}/iscsiuio
%{_mandir}/man8/iscsiuio.8.gz

%files devel
%doc libiscsi/html
%{_libdir}/libiscsi.so
%{_includedir}/libiscsi.h
%{_libdir}/libopeniscsiusr.so
%{_includedir}/libopeniscsiusr.h
%{_includedir}/libopeniscsiusr_common.h
%{_includedir}/libopeniscsiusr_iface.h
%{_includedir}/libopeniscsiusr_node.h
%{_includedir}/libopeniscsiusr_session.h
%{_libdir}/pkgconfig/libopeniscsiusr.pc

%files -n python3-%{name}
%{python3_sitearch}/*

%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.2.1.4-5.git2a8f9d8
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.2.1.4-4.git2a8f9d8
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Jun 08 2023 kianli <kianli@tencent.com> - 6.2.1.4-3.git2a8f9d8
- Renumber use-opencloudos-as-default-iqn-name.patch

* Wed Jun 07 2023 kianli <kianli@tencent.com> - 6.2.1.4-2.git2a8f9d8
- use opencloudos as default iqn name

* Wed Nov 16 2022 Xiaojie Chen <jackxjchen@tencent.com> - 6.2.1.4-1.git2a8f9d8
- Initial build
